package com.sk.newsplayer.model;

import java.util.List;

import android.content.Context;
import android.net.Uri;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import com.sk.newsplayer.R;
import com.sk.newsplayer.util.LogUtils;

public class NewsItemAdapter extends BaseAdapter {

	private static final String TAG = "NewsItemAdapter";
	
	private Context mContext;
	private List<NewsItem> mList;
	private LayoutInflater mInflater;
	
	public NewsItemAdapter(Context context, List<NewsItem> articles){
		mContext = context;
		mList = articles;
		mInflater = (LayoutInflater)context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
	}

	public int getCount() {
		return mList.size();
	}

	public NewsItem getItem(int position) {
		return mList.get(position);
	}
	
	public void setItems(List<NewsItem> items){
		mList = items;
		//notifyDataSetChanged();
	}

	public long getItemId(int position) {
		return position;
	}
	

//	public NewsItemAdapter setItem(int position, NewsItem newItem) {
//		mList.set(position, newItem);
//		return this;
//	}
//	
//	public NewsItemAdapter setStatus(int position, int value){
//		if (getItem(position).status!= value){
//			getItem(position).status = value;
//			this.notifyDataSetChanged();
//			LogUtils.w(TAG, "######## setStatus notifyDataSetChanged. position:"+position + " Status:" + value);
//		}
//		return this;
//	}

	@Override
	public View getView(final int position, View convertView, ViewGroup parent) {
		
		TextView titleText, summaryText;
		ImageView image1;
		
		NewsItem aItem = mList.get(position);

		if (convertView==null){
			convertView = mInflater.inflate(R.layout.newsitem, parent, false);
		} 		
		
		titleText 	= (TextView)convertView.findViewById(R.id.text1);
		summaryText = (TextView)convertView.findViewById(R.id.text2);
		image1 		= (ImageView)convertView.findViewById(R.id.image1);
		
		titleText.setText(aItem.title);
		summaryText.setText(aItem.summary);
		if (!TextUtils.isEmpty(aItem.icon))
			image1.setImageURI(Uri.parse(aItem.icon));
		
		return convertView;
	}

	public List<NewsItem> getList() {
		return mList;
	}
	
	public void clear(){
		this.mList.clear();
		this.notifyDataSetChanged();
	}
	
	public void addItem(NewsItem item){
		this.mList.add(item);
		this.notifyDataSetChanged();
	}
	
}
