package com.sk.newsplayer.model;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;

import android.os.AsyncTask;

import com.sk.newsplayer.util.LogUtils;

public class NewsListTaskOrg extends AsyncTask<String, Void, Void>{

	private static final String TAG = NewsListTaskOrg.class.getSimpleName();
	//private static final int BUFFER_SIZE = 1024;
	
	//private static final String QUOTE = "&quot;";
	//private static final String AMP = "&amp;";
	
	private NewsListListener mListener;
	private List<NewsItem> mItems;
	//private String packageName;
	//private NewsDownloaderListener<NewsItem> listener;
	
	public NewsListTaskOrg(NewsListListener listener){
		mListener = listener;
		//this.packageName = packageName;
		//this.progressBar = progressBar;
		//this.listener = listener;
	}
	
    @Override
    protected void onPreExecute() {
        super.onPreExecute();
    }

	
	@Override
	// Actual download method, run in the task thread
    protected Void doInBackground(String... urls) {
		getNewsList(urls[0]);
		
		return null;
    }
	
//	@Override
//	protected void onProgressUpdate(NewsItem... items) {
//		//super.onProgressUpdate(values);
//		if (mListener!=null)
//			mListener.onProgress(items[0]);
//	}

	//Redraw list view
	@Override
	protected void onPostExecute(Void result) {
    	if (mListener!=null)
    		mListener.onDone(mItems);
	}
	
	
	private void getNewsList(String url) {
		if (mItems==null)
			mItems = new ArrayList<NewsItem>();
		
		mItems.clear();
		
	    try {
	    	Document doc = Jsoup.connect(url)
	  				//.timeout(6000)
	  				.get();
	    	
	    	Elements storyTeasers = doc.select(".story-teaser");// .story-teaser");
	    	
	    	for (Element item : storyTeasers){
	    		Elements date 	 = item.select(".main>div.date");
	    		Elements title 	 = item.select(".main>h4>a");
	    		Elements summary = item.select(".main>p");
	    		Elements storyPlayer = item.select("div.storyplayer>a");
	    		
	    		NewsItem newsItem = new NewsItem();
	    		newsItem.newsId      = item.id();
	    		newsItem.lastUpdated = date.text();
	    		newsItem.title 		= title.text();
	    		newsItem.summary 	= summary.text();
	    		newsItem.moreLink   = title.attr("href");
	    		newsItem.audioLink  = storyPlayer.attr("href");
	    		
	    		mItems.add(newsItem);
	    		
	    		LogUtils.d(TAG, "" + newsItem);
	    	}
	    	
	    } catch (IOException e) {
	        // Could provide a more explicit error message for IOException or IllegalStateException
	        LogUtils.e("NewsDownloader", "Error while retrieving content from " + url + ":" + e.getMessage());
	    } 
	    
	}
/*
	private String downloadAudio(NewsItem article) {
		String result = null;
		
		HttpParams httpParams = new BasicHttpParams();
		HttpConnectionParams.setConnectionTimeout(httpParams, 6000);
		HttpConnectionParams.setSoTimeout(httpParams, 20000);

///		final AndroidHttpClient client = AndroidHttpClient.newInstance("Android");
		final HttpClient client = new DefaultHttpClient(httpParams);
	    final HttpGet getRequest = new HttpGet(article.audioLink);
	    	
	    try {
	        HttpResponse response = client.execute(getRequest);
	        final int statusCode = response.getStatusLine().getStatusCode();
	        if (statusCode != HttpStatus.SC_OK) { 
	            LogUtils.w("NewsDownloader", "Error " + statusCode + " while retrieving audio file from " + article.audioLink); 
	            return null;
	        }
	        
	        final HttpEntity entity = response.getEntity();
	        if (entity != null) {
	            InputStream is = null;
	            FileOutputStream fos = null;
	            try {
	            	is = new BufferedInputStream(entity.getContent()); 
	    			
	            	result = SysUtils.getFileNameWithUrl(article.audioLink, packageName);
	    			LogUtils.d(TAG, "saveFileName============>" + result);
	    			
	    			//is = conn.getInputStream();
	    			fos = new FileOutputStream(new File(result));

	    			byte[] b = new byte[BUFFER_SIZE];
	    			int bytesRead, receivedBytes = 0;
	    			while ((bytesRead = is.read(b, 0, BUFFER_SIZE))!=-1){
	    				fos.write(b, 0, bytesRead);
	    				receivedBytes += bytesRead;
	    				//LogUtils.d(TAG, String.format("downloaded Size:%d/%d", receivedBytes, totalSize));
	    			}

	    			fos.flush();
	                
	    			article.filePath = result;
	    			article.status = NewsItem.DONE;
	    			
	            } finally {
	            	if (fos!=null) try{fos.close();}catch(Exception e){}
	    			if (is!=null) try{is.close();}catch(Exception e){}
	                entity.consumeContent();
	            }
	        }
	    } catch (SocketTimeoutException e) {
	        // Could provide a more explicit error message for IOException or IllegalStateException
	    	article.status = NewsItem.NONE;
	        getRequest.abort();
	        LogUtils.e("NewsDownloader", "Error while retrieving bitmap from " + article.audioLink + ":" + e.getMessage());
	        //throw new NewsDownloadException("Socket timeout error");
	    } catch (SocketException e) {
	    	//throw new NewsDownloadException("Socket error:" + e.getMessage());
	    } catch (IOException e) {
	    	//throw new NewsDownloadException("IO error:" + e.getMessage());
	    } finally {
	        if (client != null) {
	            //client.close();
	        }
	    }
	    
	    return result;
	}
	*/

	public static interface NewsListListener {
		
		//public void onProgress(NewsItem item);
		public void onDone(List<NewsItem> items);
		
	}

}
