package com.sk.newsplayer.service;

import java.io.IOException;

import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;

import android.content.Context;
import android.os.AsyncTask;

import com.sk.newsplayer.util.LogUtils;

public abstract class AbsNewsDocTask<T> extends AsyncTask<String, Void, T>{

	private static final String TAG = AbsNewsDocTask.class.getSimpleName();
	
	Context mContext = null;
	NewsListListener<T> mListener = null;
	int mTimeout = 10000;
	
	public AbsNewsDocTask(Context context){
		this.mContext = context;
	}
	
	public AbsNewsDocTask<T> setTimeout(int timeout){
		this.mTimeout = timeout;
		return this;
	}
	
	public AbsNewsDocTask<T> setListener(NewsListListener<T> listener){
		this.mListener = listener;
		return this;
	}
	
    @Override
    protected void onPreExecute() {
        //super.onPreExecute();
    	//TODO.show porgresss dialog
    }

	
	@Override
    protected T doInBackground(String... urls) {
		if (urls.length!=1){
			return null;
		}
		
		return getData(urls[0]);
    }
	
//	@Override
//	protected void onProgressUpdate(NewsItem... items) {
//		//super.onProgressUpdate(values);
//		if (mListener!=null)
//			mListener.onProgress(items[0]);
//	}

	//Redraw list view
	@Override
	protected void onPostExecute(T result) {
    	if (mListener!=null)
    		mListener.onDone(result);
    	
    	//TODO.dismiss progress dialog
	}
	
	
	protected T getData(String url) {
		
	    try {
	    	Document doc = Jsoup.connect(url)
	  				.timeout(mTimeout)
	  				.get();
	    	
	    	return parse(doc);
	    	
	    } catch (IOException e) {
	        // Could provide a more explicit error message for IOException or IllegalStateException
	        LogUtils.e(TAG, "Error while getting data:" + e.getMessage());
	    } 
	    
	    return null;
	    
	}
	
	protected abstract T parse(Document doc);
	
	public static interface NewsListListener<T> {
		
		//public void onProgress(NewsItem item);
		public void onDone(T result);
		
	}

}
