package com.sk.newsplayer;

import java.util.List;

import android.app.ListActivity;
import android.content.Intent;
import android.os.Bundle;
import android.view.Menu;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;

import com.sk.newsplayer.model.NewsItem;
import com.sk.newsplayer.model.NewsItemAdapter;
import com.sk.newsplayer.service.AbsNewsDocTask;
import com.sk.newsplayer.service.AudioPlayService;
import com.sk.newsplayer.service.NewsListTask;
import com.sk.newsplayer.util.AppUtils;

public class MainActivity extends ListActivity implements OnItemClickListener, AbsNewsDocTask.NewsListListener<List<NewsItem>> {
	
	NewsItemAdapter mAdapter;
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        
        setup();
    }

    private void setup() {
    	AppUtils.context = this;
    	
    	getListView().setOnItemClickListener(this);
    	
    	//MusicSearchTask task = new MusicSearchTask(this);
        //task.setListener(MainActivity.this).execute("http://searchmp3.mobi/mp3/payphone");
    	
    	NewsListTask task = new NewsListTask(this);
        task.setListener(MainActivity.this).execute("http://www.abc.net.au/am/");
	}

	@Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.activity_main, menu);
        return true;
    }

	@Override
	public void onDone(List<NewsItem> items) {
		mAdapter = new NewsItemAdapter(this, items);
    	getListView().setAdapter(mAdapter);
	}

	@Override
	public void onItemClick(AdapterView<?> adapterView, View view, int position, long paramLong) {
		
		NewsItem newsItem = mAdapter.getItem(position);
		
		Intent intent = new Intent(this, NewsPlayActivity.class);
		intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
		intent.putExtra(AudioPlayService.EXTRA_ITEM, newsItem);
		startActivity(intent);
	}

}
